

package ai.nextbillion.octant.rest.model;

import java.util.Objects;
import java.util.Arrays;

import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

import java.io.IOException;

import ai.nextbillion.octant.rest.ObjectsHelper;

/**
 * ProtobufAny
 */
public class ProtobufAny {
    @SerializedName("type_url")
    private String typeUrl = null;

    @SerializedName("value")
    private byte[] value = null;

    public ProtobufAny typeUrl(String typeUrl) {
        this.typeUrl = typeUrl;
        return this;
    }

    /**
     * Get typeUrl
     *
     * @return typeUrl
     **/
    public String getTypeUrl() {
        return typeUrl;
    }

    public void setTypeUrl(String typeUrl) {
        this.typeUrl = typeUrl;
    }

    public ProtobufAny value(byte[] value) {
        this.value = value;
        return this;
    }

    /**
     * Get value
     *
     * @return value
     **/
    public byte[] getValue() {
        return value;
    }

    public void setValue(byte[] value) {
        this.value = value;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ProtobufAny protobufAny = (ProtobufAny) o;
        return ObjectsHelper.equals(this.typeUrl, protobufAny.typeUrl) &&
                Arrays.equals(this.value, protobufAny.value);
    }

    @Override
    public int hashCode() {
        return ObjectsHelper.hash(typeUrl, Arrays.hashCode(value));
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ProtobufAny {\n");

        sb.append("    typeUrl: ").append(toIndentedString(typeUrl)).append("\n");
        sb.append("    value: ").append(toIndentedString(value)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

