

package ai.nextbillion.octant.rest.model;

import com.google.gson.annotations.SerializedName;

import java.util.ArrayList;
import java.util.List;

import ai.nextbillion.octant.rest.ObjectsHelper;

/**
 * ProtoQueryAggregationRequest
 */
public class QueryAggregationRequest {
    @SerializedName("start")
    private String start = null;

    @SerializedName("end")
    private String end = null;

    @SerializedName("from")
    private String from = null;

    @SerializedName("limit")
    private String limit = null;

    @SerializedName("userCode")
    private List<String> userCode = null;

    @SerializedName("teamCode")
    private String teamCode = null;

    @SerializedName("remarkCode")
    private String remarkCode = null;

    public QueryAggregationRequest start(String start) {
        this.start = start;
        return this;
    }

    /**
     * Get start
     *
     * @return start
     **/
    public String getStart() {
        return start;
    }

    public void setStart(String start) {
        this.start = start;
    }

    public QueryAggregationRequest end(String end) {
        this.end = end;
        return this;
    }

    /**
     * Get end
     *
     * @return end
     **/
    public String getEnd() {
        return end;
    }

    public void setEnd(String end) {
        this.end = end;
    }

    public QueryAggregationRequest from(String from) {
        this.from = from;
        return this;
    }

    /**
     * Get from
     *
     * @return from
     **/
    public String getFrom() {
        return from;
    }

    public void setFrom(String from) {
        this.from = from;
    }

    public QueryAggregationRequest limit(String limit) {
        this.limit = limit;
        return this;
    }

    /**
     * Get limit
     *
     * @return limit
     **/
    public String getLimit() {
        return limit;
    }

    public void setLimit(String limit) {
        this.limit = limit;
    }


    public QueryAggregationRequest userCode(List<String> userCode) {
        this.userCode = userCode;
        return this;
    }

    public QueryAggregationRequest addUserCodeItem(String userCodeItem) {
        if (this.userCode == null) {
            this.userCode = new ArrayList<String>();
        }
        this.userCode.add(userCodeItem);
        return this;
    }

    /**
     * Get userCode
     *
     * @return userCode
     **/
    public List<String> getUserCode() {
        return userCode;
    }

    public void setUserCode(List<String> userCode) {
        this.userCode = userCode;
    }

    public QueryAggregationRequest teamCode(String teamCode) {
        this.teamCode = teamCode;
        return this;
    }

    /**
     * Get teamCode
     *
     * @return teamCode
     **/
    public String getTeamCode() {
        return teamCode;
    }

    public void setTeamCode(String teamCode) {
        this.teamCode = teamCode;
    }

    public QueryAggregationRequest remarkCode(String remarkCode) {
        this.remarkCode = remarkCode;
        return this;
    }

    /**
     * Get remarkCode
     *
     * @return remarkCode
     **/
    public String getRemarkCode() {
        return remarkCode;
    }

    public void setRemarkCode(String remarkCode) {
        this.remarkCode = remarkCode;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        QueryAggregationRequest queryAggregationRequest = (QueryAggregationRequest) o;
        return ObjectsHelper.equals(this.start, queryAggregationRequest.start) &&
                ObjectsHelper.equals(this.end, queryAggregationRequest.end) &&
                ObjectsHelper.equals(this.from, queryAggregationRequest.from) &&
                ObjectsHelper.equals(this.limit, queryAggregationRequest.limit) &&
                ObjectsHelper.equals(this.userCode, queryAggregationRequest.userCode) &&
                ObjectsHelper.equals(this.teamCode, queryAggregationRequest.teamCode) &&
                ObjectsHelper.equals(this.remarkCode, queryAggregationRequest.remarkCode);
    }

    @Override
    public int hashCode() {
        return ObjectsHelper.hash(start, end, from, limit, userCode, teamCode, remarkCode);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ProtoQueryAggregationRequest {\n");

        sb.append("    start: ").append(toIndentedString(start)).append("\n");
        sb.append("    end: ").append(toIndentedString(end)).append("\n");
        sb.append("    from: ").append(toIndentedString(from)).append("\n");
        sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
        sb.append("    userCode: ").append(toIndentedString(userCode)).append("\n");
        sb.append("    teamCode: ").append(toIndentedString(teamCode)).append("\n");
        sb.append("    remarkCode: ").append(toIndentedString(remarkCode)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

