

package ai.nextbillion.octant.rest.model;

import com.google.gson.annotations.SerializedName;

import ai.nextbillion.octant.rest.ObjectsHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * ProtoQueryAggregationResponse
 */
public class QueryAggregationResponse {
    @SerializedName("ranks")
    private List<Rank> ranks = null;

    public QueryAggregationResponse ranks(List<Rank> ranks) {
        this.ranks = ranks;
        return this;
    }

    public QueryAggregationResponse addRanksItem(Rank ranksItem) {
        if (this.ranks == null) {
            this.ranks = new ArrayList<Rank>();
        }
        this.ranks.add(ranksItem);
        return this;
    }

    /**
     * Get ranks
     *
     * @return ranks
     **/
    public List<Rank> getRanks() {
        return ranks;
    }

    public void setRanks(List<Rank> ranks) {
        this.ranks = ranks;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        QueryAggregationResponse queryAggregationResponse = (QueryAggregationResponse) o;
        return ObjectsHelper.equals(this.ranks, queryAggregationResponse.ranks);
    }

    @Override
    public int hashCode() {
        return ObjectsHelper.hash(ranks);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ProtoQueryAggregationResponse {\n");

        sb.append("    ranks: ").append(toIndentedString(ranks)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

