

package ai.nextbillion.octant.rest.model;

import java.util.Objects;

import com.google.gson.annotations.SerializedName;

import ai.nextbillion.octant.rest.ObjectsHelper;

/**
 * ProtoQueryCoordinateRequest
 */
public class QueryCoordinateRequest {
    @SerializedName("start")
    private String start = null;

    @SerializedName("end")
    private String end = null;

    @SerializedName("limit")
    private String limit = null;

    @SerializedName("userCode")
    private String userCode = null;

    @SerializedName("teamCode")
    private String teamCode = null;

    @SerializedName("remarkCode")
    private String remarkCode = null;

    public QueryCoordinateRequest start(String start) {
        this.start = start;
        return this;
    }

    /**
     * Get start
     *
     * @return start
     **/
    public String getStart() {
        return start;
    }

    public void setStart(String start) {
        this.start = start;
    }

    public QueryCoordinateRequest end(String end) {
        this.end = end;
        return this;
    }

    /**
     * Get end
     *
     * @return end
     **/
    public String getEnd() {
        return end;
    }

    public void setEnd(String end) {
        this.end = end;
    }

    public QueryCoordinateRequest limit(String limit) {
        this.limit = limit;
        return this;
    }

    /**
     * Get limit
     *
     * @return limit
     **/
    public String getLimit() {
        return limit;
    }

    public void setLimit(String limit) {
        this.limit = limit;
    }

    public QueryCoordinateRequest userCode(String userCode) {
        this.userCode = userCode;
        return this;
    }

    /**
     * Get userCode
     *
     * @return userCode
     **/
    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    public QueryCoordinateRequest teamCode(String teamCode) {
        this.teamCode = teamCode;
        return this;
    }

    /**
     * Get teamCode
     *
     * @return teamCode
     **/
    public String getTeamCode() {
        return teamCode;
    }

    public void setTeamCode(String teamCode) {
        this.teamCode = teamCode;
    }

    public QueryCoordinateRequest remarkCode(String remarkCode) {
        this.remarkCode = remarkCode;
        return this;
    }

    /**
     * Get remarkCode
     *
     * @return remarkCode
     **/
    public String getRemarkCode() {
        return remarkCode;
    }

    public void setRemarkCode(String remarkCode) {
        this.remarkCode = remarkCode;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        QueryCoordinateRequest queryCoordinateRequest = (QueryCoordinateRequest) o;
        return ObjectsHelper.equals(this.start, queryCoordinateRequest.start) &&
                ObjectsHelper.equals(this.end, queryCoordinateRequest.end) &&
                ObjectsHelper.equals(this.limit, queryCoordinateRequest.limit) &&
                ObjectsHelper.equals(this.userCode, queryCoordinateRequest.userCode) &&
                ObjectsHelper.equals(this.teamCode, queryCoordinateRequest.teamCode) &&
                ObjectsHelper.equals(this.remarkCode, queryCoordinateRequest.remarkCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(start, end, limit, userCode, teamCode, remarkCode);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ProtoQueryCoordinateRequest {\n");

        sb.append("    start: ").append(toIndentedString(start)).append("\n");
        sb.append("    end: ").append(toIndentedString(end)).append("\n");
        sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
        sb.append("    userCode: ").append(toIndentedString(userCode)).append("\n");
        sb.append("    teamCode: ").append(toIndentedString(teamCode)).append("\n");
        sb.append("    remarkCode: ").append(toIndentedString(remarkCode)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

