
package ai.nextbillion.octant.rest.model;

import com.google.gson.annotations.SerializedName;

import ai.nextbillion.octant.rest.ObjectsHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * ProtoQueryCoordinateResponse
 */
public class QueryCoordinateResponse {
    @SerializedName("userCoords")
    private List<UserCoords> userCoords = null;

    public QueryCoordinateResponse userCoords(List<UserCoords> userCoords) {
        this.userCoords = userCoords;
        return this;
    }

    public QueryCoordinateResponse addUserCoordsItem(UserCoords userCoordsItem) {
        if (this.userCoords == null) {
            this.userCoords = new ArrayList<UserCoords>();
        }
        this.userCoords.add(userCoordsItem);
        return this;
    }

    /**
     * Get userCoords
     *
     * @return userCoords
     **/
    public List<UserCoords> getUserCoords() {
        return userCoords;
    }

    public void setUserCoords(List<UserCoords> userCoords) {
        this.userCoords = userCoords;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        QueryCoordinateResponse queryCoordinateResponse = (QueryCoordinateResponse) o;
        return ObjectsHelper.equals(this.userCoords, queryCoordinateResponse.userCoords);
    }

    @Override
    public int hashCode() {
        return ObjectsHelper.hash(userCoords);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ProtoQueryCoordinateResponse {\n");

        sb.append("    userCoords: ").append(toIndentedString(userCoords)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

