
package ai.nextbillion.octant.rest.model;

import com.google.gson.annotations.SerializedName;

import ai.nextbillion.octant.rest.ObjectsHelper;

/**
 * ProtoRank
 */
public class Rank {
    @SerializedName("userCode")
    private String userCode = null;

    @SerializedName("distance")
    private String distance = null;

    @SerializedName("rank")
    private String rank = null;

    @SerializedName("lastActivate")
    private String lastActivate = null;

    public Rank userCode(String userCode) {
        this.userCode = userCode;
        return this;
    }

    /**
     * Get userCode
     *
     * @return userCode
     **/
    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    public Rank distance(String distance) {
        this.distance = distance;
        return this;
    }

    /**
     * Get distance
     *
     * @return distance
     **/
    public String getDistance() {
        return distance;
    }

    public void setDistance(String distance) {
        this.distance = distance;
    }

    public Rank rank(String rank) {
        this.rank = rank;
        return this;
    }

    /**
     * Get rank
     *
     * @return rank
     **/
    public String getRank() {
        return rank;
    }

    public void setRank(String rank) {
        this.rank = rank;
    }

    public Rank lastActivate(String lastActivate) {
        this.lastActivate = lastActivate;
        return this;
    }

    /**
     * Get lastActivate
     *
     * @return lastActivate
     **/
    public String getLastActivate() {
        return lastActivate;
    }

    public void setLastActivate(String lastActivate) {
        this.lastActivate = lastActivate;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Rank rank = (Rank) o;
        return ObjectsHelper.equals(this.userCode, rank.userCode) &&
                ObjectsHelper.equals(this.distance, rank.distance) &&
                ObjectsHelper.equals(this.rank, rank.rank) &&
                ObjectsHelper.equals(this.lastActivate, rank.lastActivate);
    }

    @Override
    public int hashCode() {
        return ObjectsHelper.hash(userCode, distance, rank, lastActivate);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ProtoRank {\n");

        sb.append("    userCode: ").append(toIndentedString(userCode)).append("\n");
        sb.append("    distance: ").append(toIndentedString(distance)).append("\n");
        sb.append("    rank: ").append(toIndentedString(rank)).append("\n");
        sb.append("    lastActivate: ").append(toIndentedString(lastActivate)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

