
package ai.nextbillion.octant.rest.model;

import java.util.Objects;
import java.util.Arrays;

import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

import ai.nextbillion.octant.rest.ObjectsHelper;
import ai.nextbillion.octant.rest.model.ProtobufAny;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * RuntimeError
 */
public class RuntimeError {
    @SerializedName("error")
    private String error = null;

    @SerializedName("code")
    private Integer code = null;

    @SerializedName("message")
    private String message = null;

    @SerializedName("details")
    private List<ProtobufAny> details = null;

    public RuntimeError error(String error) {
        this.error = error;
        return this;
    }

    /**
     * Get error
     *
     * @return error
     **/
    public String getError() {
        return error;
    }

    public void setError(String error) {
        this.error = error;
    }

    public RuntimeError code(Integer code) {
        this.code = code;
        return this;
    }

    /**
     * Get code
     *
     * @return code
     **/
    public Integer getCode() {
        return code;
    }

    public void setCode(Integer code) {
        this.code = code;
    }

    public RuntimeError message(String message) {
        this.message = message;
        return this;
    }

    /**
     * Get message
     *
     * @return message
     **/
    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public RuntimeError details(List<ProtobufAny> details) {
        this.details = details;
        return this;
    }

    public RuntimeError addDetailsItem(ProtobufAny detailsItem) {
        if (this.details == null) {
            this.details = new ArrayList<ProtobufAny>();
        }
        this.details.add(detailsItem);
        return this;
    }

    /**
     * Get details
     *
     * @return details
     **/
    public List<ProtobufAny> getDetails() {
        return details;
    }

    public void setDetails(List<ProtobufAny> details) {
        this.details = details;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        RuntimeError runtimeError = (RuntimeError) o;
        return ObjectsHelper.equals(this.error, runtimeError.error) &&
                ObjectsHelper.equals(this.code, runtimeError.code) &&
                ObjectsHelper.equals(this.message, runtimeError.message) &&
                ObjectsHelper.equals(this.details, runtimeError.details);
    }

    @Override
    public int hashCode() {
        return ObjectsHelper.hash(error, code, message, details);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class RuntimeError {\n");

        sb.append("    error: ").append(toIndentedString(error)).append("\n");
        sb.append("    code: ").append(toIndentedString(code)).append("\n");
        sb.append("    message: ").append(toIndentedString(message)).append("\n");
        sb.append("    details: ").append(toIndentedString(details)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

