
package ai.nextbillion.octant.rest.model;

import com.google.gson.annotations.SerializedName;

import ai.nextbillion.octant.rest.ObjectsHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * ProtoUserCoords
 */
public class UserCoords {
    @SerializedName("userCode")
    private String userCode = null;

    @SerializedName("teamCode")
    private String teamCode = null;

    @SerializedName("remarkCode")
    private String remarkCode = null;

    @SerializedName("Coords")
    private List<Coordinate> coords = null;

    public UserCoords userCode(String userCode) {
        this.userCode = userCode;
        return this;
    }

    /**
     * Get userCode
     *
     * @return userCode
     **/
    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    public UserCoords teamCode(String teamCode) {
        this.teamCode = teamCode;
        return this;
    }

    /**
     * Get teamCode
     *
     * @return teamCode
     **/
    public String getTeamCode() {
        return teamCode;
    }

    public void setTeamCode(String teamCode) {
        this.teamCode = teamCode;
    }

    public UserCoords remarkCode(String remarkCode) {
        this.remarkCode = remarkCode;
        return this;
    }

    /**
     * Get remarkCode
     *
     * @return remarkCode
     **/
    public String getRemarkCode() {
        return remarkCode;
    }

    public void setRemarkCode(String remarkCode) {
        this.remarkCode = remarkCode;
    }

    public UserCoords coords(List<Coordinate> coords) {
        this.coords = coords;
        return this;
    }

    public UserCoords addCoordsItem(Coordinate coordsItem) {
        if (this.coords == null) {
            this.coords = new ArrayList<Coordinate>();
        }
        this.coords.add(coordsItem);
        return this;
    }

    /**
     * Get coords
     *
     * @return coords
     **/
    public List<Coordinate> getCoords() {
        return coords;
    }

    public void setCoords(List<Coordinate> coords) {
        this.coords = coords;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        UserCoords userCoords = (UserCoords) o;
        return ObjectsHelper.equals(this.userCode, userCoords.userCode) &&
                ObjectsHelper.equals(this.teamCode, userCoords.teamCode) &&
                ObjectsHelper.equals(this.remarkCode, userCoords.remarkCode) &&
                ObjectsHelper.equals(this.coords, userCoords.coords);
    }

    @Override
    public int hashCode() {
        return ObjectsHelper.hash(userCode, teamCode, remarkCode, coords);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ProtoUserCoords {\n");

        sb.append("    userCode: ").append(toIndentedString(userCode)).append("\n");
        sb.append("    teamCode: ").append(toIndentedString(teamCode)).append("\n");
        sb.append("    remarkCode: ").append(toIndentedString(remarkCode)).append("\n");
        sb.append("    coords: ").append(toIndentedString(coords)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

