import 'package:octant/models/coordinate.dart';

class UserCoords {
  String? userCode;

  String? teamCode;

  String? remarkCode;

  List<Coordinate> coords = [];

  UserCoords();

  @override
  String toString() {
    return 'UserCoords[userCode=$userCode, teamCode=$teamCode, remarkCode=$remarkCode, coords=$coords, ]';
  }

  UserCoords.fromJson(Map<String, dynamic>? json) {
    if (json == null) return;
    userCode = json['userCode'];
    teamCode = json['teamCode'];
    remarkCode = json['remarkCode'];
    coords = Coordinate.listFromJson(json['Coords']);
  }

  Map<String, dynamic> toJson() {
    return {
      'userCode': userCode,
      'teamCode': teamCode,
      'remarkCode': remarkCode,
      'Coords': coords
    };
  }

  static List<UserCoords> listFromJson(List<dynamic>? json) {
    return json == null
        ? <UserCoords>[]
        : json.map((value) => UserCoords.fromJson(value)).toList();
  }

  static Map<String, UserCoords> mapFromJson(
      Map<String, Map<String, dynamic>>? json) {
    var map = <String, UserCoords>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, Map<String, dynamic> value) =>
          map[key] = UserCoords.fromJson(value));
    }
    return map;
  }
}
